require "spec_helper"

describe JsonTest::Memory do
  it "has a memory" do
    JsonTest.memory.should == {}
  end

  it "memorizes strings" do
    JsonTest.memorize(:key, "value")
    JsonTest.memory.should == { key: "value" }
  end

  it "symbolizes keys" do
    JsonTest.memorize("key", "value")
    JsonTest.memory.should == { key: "value" }
  end

  it "regurgitates unremembered strings" do
    JsonTest.remember("foo%{bar}").should == "foo%{bar}"
  end

  it "remembers strings" do
    JsonTest.memorize(:bar, "baz")
    JsonTest.remember("foo%{bar}").should == "foobaz"
  end

  it "forgets" do
    JsonTest.memorize(:key, "value")
    JsonTest.forget
    JsonTest.memory.should == {}
  end
end
